//  Copyright (C) 2005 SoftKAM. All Rights Reserved.
//
//  InjectManifest is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.


#include <stdio.h>
#include <windows.h>

int main(int argc, char *argv[])
{
	HANDLE	hUpdate;
	FILE	*f;
	char	*buf;
	int		size;
//
	if (argc != 3)
	{
		fprintf(stderr, "Usage: InjectManifest <executable> <manifest>\n");
		return -1;
	}
	f = fopen(argv[2], "rb");
	if (f == NULL)
	{
		fprintf(stderr, "Error trying to open manifest file '%s'\n", argv[2]);
		return -1;
	}
	fseek(f, 0L, SEEK_END);
	size = ftell(f);
	buf = (char *)malloc(size);
	if (buf == NULL)
	{
		fprintf(stderr, "Error allocing %d bytes\n", size);
		fclose(f);
		return -1;
	}
	rewind(f);
	fread(buf, 1, size, f);
	fclose(f);
	hUpdate = BeginUpdateResource(argv[1], FALSE);
	if (hUpdate == NULL)
	{
		fprintf(stderr, "Error trying to open executable image '%s'\n", argv[1]);
		free(buf);
		return -1;
	}
	if (!UpdateResource(hUpdate, MAKEINTRESOURCE(24), MAKEINTRESOURCE(1), 0, buf, size))
	{
		fprintf(stderr, "Error %x updating resource\n", GetLastError());
	}
	EndUpdateResource(hUpdate, FALSE);
	free(buf);
	printf("%s inserted into %s\n", argv[2], argv[1]);
//
	return 0;
}
